
      IMPLICIT DOUBLE PRECISION(a-h,o-z)

      Parameter(NN=200000000)
      
      Parameter(NNN=1000000)
      Parameter(Nfile=11)

      real*8 time(NN)
      real ave(Nfile),fftr(NNN),avebgd(Nfile),Tave,Taveseg
       COMPLEX fft(Nfile,NNN),coher(Nfile,NNN),Tcoher(Nfile),cval,cvala
       COMPLEX cohertot(Nfile,NNN)
       real signi(Nfile)
       real*8 Emin(Nfile),Emax(Nfile)
       real P(Nfile,NNN),PT(NNN),PTT(Nfile),Ptot(Nfile,NNN),PTTT(NNN)
       character*50 filename(Nfile),fileout1,fileout2,energy_cha_file
        character*50 user_gti_file,fileout,eneinput
       character*50 file_bkg_pha,file_bkg_rsp
        character*5 fj
        character*3 pcu
       integer itstart(500),itstop(500),nrows(Nfile),jtime(Nfile)
       integer icmin(Nfile),icmax(Nfile)
	integer itstartu(500),itstopu(500),ich(2000)
        real ecmin(2000),ecmax(2000)
        integer*1 ia1
       logical dofft,gtinotfits


      
       taud = 42.*1e-6 


       call readinput(filename(1),fileout,user_gti_file,pcu,freq_max
     1 ,freq_min,ifreq,frequser,lxpref,eneinput,taud)
       
        
        Npcu = 3
       if(pcu .ne. 'all')then
             if(pcu .eq. '1  ')Npcu=1
             if(pcu .eq. '2  ')Npcu=1
             if(pcu .eq. '3  ')Npcu=1
             if(pcu .eq. '12 ')Npcu=2
             if(pcu .eq. '23 ')Npcu=2
             if(pcu .eq. '13 ')Npcu=2
             if(pcu .eq. '21 ')Npcu=2
             if(pcu .eq. '32 ')Npcu=2
             if(pcu .eq. '31 ')Npcu=2
         endif  



c$$$        open(unit=30,file='freq_lag_eve_inputs',status='old')
c$$$        read(30,*) filename(1)
c$$$        read(30,*) user_gti_file
c$$$        read(30,*) pcu
c$$$        read(30,*) freq_max
c$$$       read(30,*) freq_min
c$$$       read(30,*) ifreq, frequser
c$$$       read(30,*) freqpeakmax,freqpeakmin
c$$$       read(30,*) imixpcu, lxpref
c$$$       
c$$$        do j = 1,Nfile
c$$$           read(30,*,end=41,err=41)Emin(j),Emax(j)
c$$$           jfile_num=j
c$$$           
c$$$       enddo
c$$$ 41    continue
c$$$
c$$$       fileout=filename(1)
c$$$
c$$$       close(30)

              jfile_num=2
       Emin(1) = 3.0
       Emax(1) = 15.0
       Emin(2) = 15.0
       Emax(2) = 30.0
       
       open(unit=30,err=83,file=eneinput,status='old')
       
        do j = 1,9
           read(30,*,end=41,err=41)Emin(j),Emax(j)
           jfile_num=j
       enddo
 41    continue
       close(30)
       write(*,*) 'Using Energy bins from file: ', eneinput 
 83    continue

       if(jfile_num+1 .gt. Nfile)then
          write(*,*) 'Too many energy bins ',jfile_num
          write(*,*) 'Maxmium allowed = ',Nfile-1
          write(*,*) 'Taking only that many bins'
          jfile_num = Nfile-1
       endif



       if(freq_max .lt. freq_min)then
          val=freq_max
          freq_max=freq_min
          
          freq_min=val
       endif

       freqpeakmax = freq_max
       freqpeakmin=freq_min

       if(lxpref .eq. 0)imixpcu=0
       nsegments=1

       
       

       
       

       
       open(unit=83,file='powfiles')
 
       

       NNC = NN/(jfile_num+1)
       

c$$$      call read_data(time,imax,deltat,NN,pcu,filename,ave
c$$$     1,itstart,itstop,jgti,freq_max,timemem,NNC,nrows
c$$$     2,jfile_num,itstartu,itstopu,jgtiu,Emin,Emax,jfile_num
c$$$     3,imixpcu, lxpref)

       ilayer=0
        call read_data_fits(time,imax,deltat,NN,filename,ave
     1,itstart,itstop,jgti,freq_max,timemem,NNC,nrows
     2,jfile_num,itstartu,itstopu,jgtiu,Emin,Emax,jfile_num,pcu
     3, user_gti_file,gtinotfits,ilayer)



        do j=1,jfile_num
         avebgd(j) = 0.0
      enddo

     
       call calback(emin,emax,jfile_num,pcu,avebgd)

      
        do j=1,jfile_num
           
         avebgd(j) = avebgd(j)*deltat
        enddo
     
     

     
      

      jamaxn = 2**nint(log(1./(freq_min*deltat))/log(2.0))
      
      if(jamaxn .gt. NNN)then
         write(*,*) 'too many points per segment', jamaxn,NNN
         stop
      endif

      iseg = imax/jamaxn

      
      freq_max = 1./deltat/2.
      freq_min = 1./(jamaxn*deltat)
      ja = int(float(itstop(jgti))/float(jamaxn))
      
      iseg = min(iseg,ja)
      write(*,*) 'Total no of segments = ', iseg
      write(*,*) 'total no of points in lC= ',imax
      write(*,*) 'time resultion (secs) = ', deltat
      write(*,*) 'maximum frequency (Hz) = ', freq_max
      write(*,*) 'minimum frequency (Hz) = ', freq_min
      write(*,*) 'No of bins per segment = ', jamaxn
     
      
      if(freqpeakmin .lt. freq_min)freqpeakmin=freq_min
      if(freqpeakmin .gt. freq_max)freqpeakmin=freq_min
      if(freqpeakmax .gt. freq_max)freqpeakmax=freq_max
      if(freqpeakmax .lt. freq_min)freqpeakmax=freq_max


      do jf = 1,jfile_num+1
      ave(jf) = 0.0
      enddo

      iseg_part = iseg/nsegments

      do j=1,jamaxn/2+1
         do ja = 1,jfile_num+1
         Ptot(ja,j) = 0.0
         coherTot(ja,j) = (0.0,0.0)
         coher(ja,j) = (0.0,0.0)
         P(ja,j) = 0.0
         enddo
         Pt(j) = 0.0
         PTTT(j) = 0.0
      enddo
      taveseg=0.0
      write(*,*) "start time" , " integer stop time" ,jgti
      do j=1,jgti
         
         write(*,*) (itstart(j)-1)*deltat,itstop(j)*deltat
      enddo
	if(jgtiu .ne. 0)then
	write(*,*) "User start and stop time" 
	do j=1,jgtiu
         
         write(*,*) (itstartu(j)-1)*deltat,itstopu(j)*deltat
      enddo
	endif
      isegn=0
      isega = 0
      isegr=0
      itnum=1
      itnumu=1
      fpeak=0.0
      ppeak=0.0
      
      P1t = 0.0
      P2t = 0.0
      Tfreq = 0.0
      iseg_partn=0
      do j=1,jfile_num+1
      jtime(j)=1
      Tcoher(j)=(0.0,0.0)
      PTT(j) = 0.0
      enddo

      fileout2 = 'Dyn_'//fileout
         if(nsegments .gt. 1)open(unit=10,file=fileout2)
         timeamem=0.0


      do ia =1,iseg
         
      ja = (ia-1)*jamaxn
      dofft=.true.
      if(ja+1 .lt. itstart(itnum))dofft=.false.
      if(ja+jamaxn .gt. itstop(itnum))then

        
         dofft=.false.
         if(itnum .lt. jgti)itnum=itnum+1
      endif

	if(jgtiu .ne. 0)then
	
	if(ja+1 .lt. itstartu(itnumu))dofft=.false.
      if(ja+jamaxn .gt. itstopu(itnumu))then

        
         dofft=.false.
         if(itnumu .lt. jgtiu)itnumu=itnumu+1
      endif
	
        endif
	
      if(dofft)then

         do jf = 1,jfile_num+1
            
         do ja1 = 1,jamaxn
         fftr(ja1) = 0.0
      enddo
     
        
 100     continue
         ja1 = int((time((jf-1)*NNC+jtime(jf))-timemem)/deltat)+1 
     1         - (ia-1)*jamaxn
        
         if(jtime(jf) .lt. nrows(jf))then
         if(ja1 .le. jamaxn)then
           if(ja1 .gt. 0)then
              fftr(ja1) =fftr(ja1)+1.
              ave(jf) = ave(jf)+1
              Taveseg = Taveseg+1
           endif
            jtime(jf)=jtime(jf)+1
         goto 100
         else
            
         endif
         endif


         call realft(fftr,jamaxn)

         jas = 3
      do j=2,jamaxn/2
         fft(jf,j) = complex(fftr(jas),fftr(jas+1))
         jas = jas+2         
      enddo
       fft(jf,jamaxn/2+1) = complex(fftr(2),0.0)

        
       enddo

        
 

         isega = isega +1
         isegr = isegr+1
         
      do j=2,jamaxn/2+1


         P(1,j) = P(1,j) + cabs(fft(1,j))**2

         cval = fft(1,j)
         do jf = 2,jfile_num
         cvala = fft(1,j)*conjg(fft(jf,j))

         coher(jf,j) = coher(jf,j) + cvala

        
         
         P(jf,j) = P(jf,j) + cabs(fft(jf,j))**2
         cval = cval+fft(jf,j)
         enddo
         PT(j) = PT(j) + cabs(cval)**2
!         write(*,*) PT(j),P(1,j),P(2,j),P(3,j),P(4,j)
      
      enddo
      endif

     


      if(isegr .eq. iseg_part .or. ia .eq. iseg)then
	
        if(ia .eq. iseg)iseg_part=isegr
         Pmax=0.0

	 dfreq = 1./(jamaxn*deltat)

       
         do ja = 2,jamaxn/2+1
            freq = (ja-1)/(jamaxn*deltat)
            if(freq .gt. freqpeakmin-dfreq .and. 
     1 freq .lt. freqpeakmax+dfreq)then
            if(PT(ja) .gt. Pmax)then
!               write(*,*) PT(ja),Pmax,ja,freq
               Pmax=PT(ja)
               jpeak = ja
	    
            endif
            endif
         enddo
            
            freq = (jpeak-1)/(jamaxn*deltat)
            if(ifreq .eq. 1)then
               jpeaka = nint(frequser*jamaxn*deltat + 1)
               if(jpeaka .lt. 2 .or. jpeaka .gt. jamaxn/2+1)then
               write(*,*) 'user frequency out of range'
               write(*,*) 'reverting to max power freq'
               else
                jpeak=jpeaka
                freq = (jpeak-1)/(jamaxn*deltat)
               endif
            endif   
	    
	   write(*,*) "Frequency used for Lag (Hz) ", freq 
            do jf=1,jfile_num
              if(jf .gt. 1)then
!        cohera = (cabs(coher(jf,jpeak))**2)/((P(1,jpeak)*P(jf,jpeak)))
!         dcoher = sqrt(2.0)*cohera*(1.-cohera)/sqrt(cohera*(iseg_part))
!           signi(jf) = cohera/dcoher
            Tcoher(jf) = Tcoher(jf)+coher(jf,jpeak)
              endif
            Ptt(jf) = Ptt(jf) + P(jf,jpeak)
            enddo
            isegn=isegn+iseg_part
	    
            Tfreq = Tfreq+freq
            iseg_partn = iseg_partn+1
            
            
!         write(*,*)iseg_partn,freq,(signi(jf),jf=2,jfile_num),
!     1 iseg_part,isegn
          isegr=0 
            taveseg = taveseg/(jamaxn*iseg_part)
          timea = (jamaxn*deltat*iseg_part*ia-timeamem)/2.0
          do ja = 2,jamaxn/2+1
              do jf = 1,jfile_num
            Ptot(jf,ja) = Ptot(jf,ja)+P(jf,ja)
            cohertot(jf,ja) = cohertot(jf,ja) + coher(jf,ja)
         coher(jf,ja) = (0.0,0.0)
         P(jf,ja) = 0.0
             enddo
                  if(nsegments .gt. 1)then
         freq = (ja-1)/(jamaxn*deltat)
         dfreq = 1./(jamaxn*deltat)
        
         call find_pow(Taveseg,jamaxn,iseg_part,Pt(ja),Ps,Pn,dPs)
!         write(*,*) taveseg,jamaxn,iseg_part,Pt(ja),Ps,Pn,dPs
!         pause
         Ps = Ps/dfreq
         Pn = Pn/dfreq
         dPs = dPs/dfreq
         
         
         write(10,*) timea,freq,Ps,dPs,Pn,taveseg,iseg_part
         endif
         PTTt(ja) = PTTt(ja) + Pt(ja)
         Pt(ja) = 0.0
          
            
         enddo
         Taveseg=0.0  
         timeamem=timea
         if(nsegments .gt. 1)write(10,*) 
      endif

      enddo
      iseg = isega

      do jf=1,jfile_num+1
        ave(jf) = ave(jf)/(jamaxn*iseg)

      enddo

      Tave=0.0
      Tavebgd=0.0
     
      
       do j=1,jfile_num
      
      Tave = Tave+ave(j)
      Tavebgd = Tavebgd+avebgd(j)
      enddo
     
       write(*,*) Tave/deltat, ' !Average count rate for all energies'
       
        TaveT=Tave+ave(jfile_num+1)
      
      write(*,*) 'Total no of segments used = ', isegn, "of ",iseg
      rates = TaveT/deltat/Npcu
      rateT =  rates/(1.-rates*taud)

      write(*,*) 'Average count rate and background rate'
      do j=1,jfile_num
         avebgd(j) = avebgd(j)/(1.+rateT*taud)
         write(*,*) 'For ', j,'lC = ', ave(j)/deltat,avebgd(j)/deltat
      
      enddo
       Tavebgd = Tavebgd/(1.+rateT*taud)
      

      if(isegn .gt. 0)then

          cohera = 1.0
         dcoher = 0.0
         pha = 0.0
         dpha = 0.0
         coheran=1.0
       dcohern=0.0


         fileout2 = 'TPow_'//fileout
         open(unit=10,file=fileout2)

         E = (Emin(1)+Emax(jfile_num))/2.
         dE = -(Emin(1)-Emax(jfile_num))/2.
         
        dfreq = 1./(jamaxn*deltat)
       do ja = 2,jamaxn/2+1
         freq = (ja-1)/(jamaxn*deltat)

        call find_pow(Tave,jamaxn,isegn,Pttt(ja),Ps,Pn,dPs)
         
         Ps = Ps/dfreq
         Pn = Pn/dfreq
         dPs = dPs/dfreq

         rate0 = Tave/deltat
         rate0A=rate0/Npcu

         
 
          Pna = f_Pna(freq,rateT,rate0A,taud)/(rate0*2)

          val = (Tave/(Tave-Tavebgd))**2
         Ps=Ps*val
         dPs = dPs*val 
         Pna=Pna*val
         Pn=Pn*val
          
         write(10,*) E,dE,freq,cohera,dcoher,pha,dpha,Ps,dPs,
     1coheran,dcohern,Pna,Pn
         
        enddo

        close(10)

        dfreq = 1./(jamaxn*deltat)

        freqc = Tfreq/float(iseg_partn)
          fileout2 = 'Lag_'//fileout
         open(unit=10,file=fileout2)


        rate0 = ave(1)/deltat
         rate0A=rate0/Npcu
 
          Pna1 = f_Pna(freqc,rateT,rate0A,taud)/(rate0*2)
          
          ja = freqc*jamaxn*deltat+1
          call find_pow(ave(1),jamaxn,isegn,Ptot(1,ja),Ps,Pn,dPs)
          fract1=Pna1*dfreq/Pn
         
         
        call find_rms(ave(1),jamaxn,isegn,Ptt(1),frms,dfrms,fract1)

        frms=frms*(ave(1)/(ave(1)-avebgd(1)))
        dfrms=dfrms*(ave(1)/abs((ave(1)-avebgd(1))))
        if(frms .lt. 0.0)frms=1e-25

       
 
       E = (Emax(1)+Emin(1))/2.
       dE = (Emax(1)-Emin(1))/2.
      write(10,*)E,DE,freqc,cohera,dcoher,pha,dpha,frms,dfrms,
     1coheran,dcohern 
!      write(*,*)E,DE,freqc,cohera,dcoher,pha,dpha,frms,dfrms,
!     1coheran,dcohern 



      ia1=1
       write(fj,*) ia1
       fileout1 = fj//'Pow_'//fileout
       Ind=1
      do while (INd .eq. 1)
      INd = index(fileout1,' ')      
      if(Ind .eq. 1)then
      fileout1 = fileout1(Ind+1:)      
       endif
      enddo
       
       open(unit=50,file=fileout1)

       write(83,*) fileout1


       

      
      do ja = 2,jamaxn/2+1
         freq = (ja-1)/(jamaxn*deltat)
         call find_pow(ave(1),jamaxn,isegn,Ptot(1,ja),Ps,Pn,dPs)
         Ps = Ps/dfreq
         Pn = Pn/dfreq
         dPs = dPs/dfreq
         
         


         rate0 = ave(1)/deltat
         rate0A=rate0/Npcu
 
          Pna = f_Pna(freq,rateT,rate0A,taud)/(rate0*2)
          val = (ave(1)/(ave(1)-avebgd(1)))**2
          Ps=Ps*val
         dPs = dPs*val
         Pna=Pna*val

         write(50,*) E,dE,freq,cohera,dcoher,pha,dpha,Ps,dPs,
     1coheran,dcohern,Pna
         
      enddo

          

         do jf = 2,jfile_num

            rate0 = ave(jf)/deltat
         rate0A=rate0/Npcu
          ja = freqc*jamaxn*deltat+1
          Pna2 = f_Pna(freqc,rateT,rate0A,taud)/(rate0*2)
          call find_pow(ave(jf),jamaxn,isegn,Ptot(jf,ja),Ps,Pn,dPs)
          fract2=Pna2*dfreq/Pn
          
         
            
      call find_pha(Tcoher(jf),Ptt(1),Ptt(jf),isegn,freqc,ave(1),ave(jf)
     1,jamaxn,cohera,dcoher,pha,dpha,coheran,dcohern,fract1,fract2)
     
        
       call find_rms(ave(jf),jamaxn,isegn,Ptt(jf),frms,dfrms,fract2)

       frms=frms*(ave(jf)/(ave(jf)-avebgd(jf)))
        dfrms=dfrms*(ave(jf)/abs((ave(jf)-avebgd(jf))))
        if(frms .lt. 0.0)frms=1e-25
      
        E = (Emax(jf)+Emin(jf))/2.
       dE = (Emax(jf)-Emin(jf))/2.
      write(10,*)E,DE,freqc,cohera,dcoher,pha,dpha,frms,dfrms,
     1coheran,dcohern 
!      write(*,*)E,DE,freqc,cohera,dcoher,pha,dpha,frms,dfrms,
!     1coheran,dcohern 

       ia1=jf
       write(fj,*) ia1
       fileout1 = fj//'Pow_'//fileout
       Ind=1
      do while (INd .eq. 1)
      INd = index(fileout1,' ')      
      if(Ind .eq. 1)then
      fileout1 = fileout1(Ind+1:)      
       endif
      enddo
       
       open(unit=50,file=fileout1)
       write(83,*) fileout1

      dfreq = 1./(jamaxn*deltat)
      do ja = 2,jamaxn/2+1
         freq = (ja-1)/(jamaxn*deltat)

         rate0 = ave(jf)/deltat
         rate0A=rate0/Npcu
 
          Pna = f_Pna(freq,rateT,rate0A,taud)/(rate0*2)

          rate0 = ave(1)/deltat
         rate0A=rate0/Npcu
 
          Pna1 = f_Pna(freq,rateT,rate0A,taud)/(rate0*2)
          call find_pow(ave(1),jamaxn,isegn,Ptot(1,ja),Ps,Pn,dPs)
          fract1=Pna1*dfreq/Pn
          
          

         call find_pow(ave(jf),jamaxn,isegn,Ptot(jf,ja),Ps,Pn,dPs)
         fract2=Pna*dfreq/Pn
         
        
         
      call find_pha(cohertot(jf,ja),Ptot(1,ja),Ptot(jf,ja),isegn,freq
     1,ave(1),ave(jf),jamaxn,cohera,dcoher,pha,dpha,coheran,dcohern
     2,fract1,fract2)
         Ps = Ps/dfreq
         Pn = Pn/dfreq
         dPs = dPs/dfreq

         

           val = (ave(jf)/(ave(jf)-avebgd(jf)))**2
          Ps=Ps*val
         dPs = dPs*val
         Pna=Pna*val
         
         write(50,*) E,dE,freq,cohera,dcoher,pha,dpha,Ps,dPs,
     1coheran,dcohern,Pna
         
      enddo
      
      enddo
      endif

      

      end
      






      SUBROUTINE four1(data,nn,isign)
      INTEGER isign,nn
      REAL data(2*nn)
      INTEGER i,istep,j,m,mmax,n
      REAL tempi,tempr
      DOUBLE PRECISION theta,wi,wpi,wpr,wr,wtemp
      n=2*nn
      j=1
      do 11 i=1,n,2
        if(j.gt.i)then
          tempr=data(j)
          tempi=data(j+1)
          data(j)=data(i)
          data(j+1)=data(i+1)
          data(i)=tempr
          data(i+1)=tempi
        endif
        m=n/2
1       if ((m.ge.2).and.(j.gt.m)) then
          j=j-m
          m=m/2
        goto 1
        endif
        j=j+m
11    continue
      mmax=2
2     if (n.gt.mmax) then
        istep=2*mmax
        theta=6.28318530717959d0/(isign*mmax)
        wpr=-2.d0*sin(0.5d0*theta)**2
        wpi=sin(theta)
        wr=1.d0
        wi=0.d0
        do 13 m=1,mmax,2
          do 12 i=m,n,istep
            j=i+mmax
            tempr=sngl(wr)*data(j)-sngl(wi)*data(j+1)
            tempi=sngl(wr)*data(j+1)+sngl(wi)*data(j)
            data(j)=data(i)-tempr
            data(j+1)=data(i+1)-tempi
            data(i)=data(i)+tempr
            data(i+1)=data(i+1)+tempi
12        continue
          wtemp=wr
          wr=wr*wpr-wi*wpi+wr
          wi=wi*wpr+wtemp*wpi+wi
13      continue
        mmax=istep
      goto 2
      endif
      return
      END
C     +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE realft(data,n)
      INTEGER isign,n
      REAL data(n)
CU    USES four1
      INTEGER i,i1,i2,i3,i4,n2p3
      REAL c1,c2,h1i,h1r,h2i,h2r,wis,wrs
      DOUBLE PRECISION theta,wi,wpi,wpr,wr,wtemp
      theta=3.141592653589793d0/dble(n/2)
      c1=0.5
     
        c2=-0.5
        call four1(data,n/2,+1)
      
      wpr=-2.0d0*sin(0.5d0*theta)**2
      wpi=sin(theta)
      wr=1.0d0+wpr
      wi=wpi
      n2p3=n+3
      do 11 i=2,n/4
        i1=2*i-1
        i2=i1+1
        i3=n2p3-i2
        i4=i3+1
        wrs=sngl(wr)
        wis=sngl(wi)
        h1r=c1*(data(i1)+data(i3))
        h1i=c1*(data(i2)-data(i4))
        h2r=-c2*(data(i2)+data(i4))
        h2i=c2*(data(i1)-data(i3))
        data(i1)=h1r+wrs*h2r-wis*h2i
        data(i2)=h1i+wrs*h2i+wis*h2r
        data(i3)=h1r-wrs*h2r+wis*h2i
        data(i4)=-h1i+wrs*h2i+wis*h2r
        wtemp=wr
        wr=wr*wpr-wi*wpi+wr
        wi=wi*wpr+wtemp*wpi+wi
11    continue
      
        h1r=data(1)
        data(1)=h1r+data(2)
        data(2)=h1r-data(2)
      
      return
      END
C     ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      subroutine find_rms(ave,jamaxn,isegn,P,frms,dfrms,fract)
      IMPLICIT DOUBLE PRECISION(a-h,o-z)

      real ave,P

      

      
              PN1 = ave*jamaxn*isegn
      
         DPN1 = PN1/sqrt(float(isegn))
         DP1 = P/sqrt(float(isegn))
         frms = ((P/isegn)-fract*ave*jamaxn)/(ave**2)

         if(frms .gt. 0.0)then
       frms = sqrt(frms/(float(jamaxn)*float(jamaxn)))

       dfrms = ((DP1/isegn))/(ave**2)
       dfrms = dfrms/(float(jamaxn)*float(jamaxn))
       dfrms = dfrms/(2.*frms)
         else
           frms=0.0
           dfrms = ((DP1/isegn))/(ave**2)
       dfrms = dfrms/(float(jamaxn)*float(jamaxn))
       dfrms = sqrt(dfrms)
         endif
       
       
       end
C     ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      subroutine find_pow(ave,jamaxn,isegn,P,Ps,Pn,dPs)
      IMPLICIT DOUBLE PRECISION(a-h,o-z)

      real ave,P

      
      Ps = (P/isegn)/(ave**2)/(float(jamaxn)*float(jamaxn))
      Pn = (ave*jamaxn)/(ave**2)/(float(jamaxn)*float(jamaxn))
      DP1 = P/sqrt(float(isegn))
      dPs = (DP1/isegn)/(ave**2)/(float(jamaxn)*float(jamaxn))
             
       
       end
C     ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      Subroutine find_pha(Tcoher,Ptt1,Ptt2,isegn
     1,freq,ave1,ave2,jamaxn,cohera,dcoher,pha,dpha,coheran,dcohern
     2,fract1,fract2)



      IMPLICIT DOUBLE PRECISION(a-h,o-z)
      
      real Ptt1,Ptt2,ave1,ave2
      complex Tcoher

      cohera = (cabs(Tcoher)**2)/((Ptt1*Ptt2))
      dcoher = sqrt(2.0)*cohera*(1.-cohera)/sqrt(cohera*(isegn))
      
       pha = Imag(Tcoher)/real(Tcoher)
         pha = -atan(pha)/(2.*3.141*freq)
C     Nowak 1999, Eqn(17)
       dpha =sqrt((1.-cohera)/(2.*cohera*(isegn)))/(2.*3.141*freq)
       PN2 = ave2*jamaxn*isegn
       DPN2 = PN2/sqrt(float(isegn))
       DP2 = Ptt2/sqrt(float(isegn))
       PN1 = ave1*jamaxn*isegn
       DPN1 = PN1/sqrt(float(isegn))
       DP1 = Ptt1/sqrt(float(isegn))

       if(Ptt1 .gt. PN1 .and. Ptt2 .gt. PN2)then
       coheran = (cabs(Tcoher)**2)/(((Ptt1-fract1*PN1)*
     1(Ptt2-fract2*PN2)))
       val = (dcoher/cohera)**2 + (DPN1/(2.*(Ptt1-fract1*PN1)))**2 +
     1 (DPN2/(2.*(Ptt2-fract2*PN2)))**2
       dcohern = coheran*sqrt(val)
       else
       coheran=0.0
       dcohern=1.0
       endif
       

      end

C     ++++++++++++++++++++++++++++++++++++++++++++++++++++

      function f_Pna(f,rateT,rate0,taud)

      IMPLICIT DOUBLE PRECISION(a-h,o-z)

      tau=1./rateT

      rate0A =  rate0*(1.+rateT*taud)

      pi = acos(-1.)

      vala = 2.*pi*f*taud
      valb = 2.*pi*f*tau

      val_up = -1 + cos(vala)-valb*sin(vala)
      val_d = 2 + (valb**2) - 2*cos(vala) + 2.*valb*sin(vala)

      f_Pna = 2 + 4*(val_up/val_d)*rate0A/rateT

!      write(*,*) f,vala,valb,val_up,val_d,f_pna

      end

     


        subroutine calback(emin,emax,jfile_num,pcu,back_rate)
      

       implicit real*8(a-h,o-z)

       character*60 respfile(3)
      character*100 respfilelist
       
      dimension ecmin(2000,3),ecmax(2000,3)
      dimension emin(jfile_num),emax(jfile_num)
      dimension Nchan(3)

      character*60 bkgfile(3)
      character*100 bkgfilelist 

      character*3 pcu

      dimension bkgspec(2000,3)

      real back_rate(jfile_num)
      
      integer status

      
      do j=1,jfile_num
         back_rate(j) = 0.0
      enddo
      

       
      

      respfilelist='resp_files'

      bkgfilelist='back_files'


      call read_resp(respfile,ecmin,ecmax,Nchan,respfilelist,status)

      if(status .ne. 0)return

      

      

      call read_bkg(bkgspec,bkgfilelist,status)

      if(status .ne. 0)return

     
      do lxp=1,3

         if(pcu .ne. 'all')then
 
                    if(pcu .eq. '1  ')then
                if(lxp .ne. 1)cycle
             endif
             if(pcu .eq. '2  ')then
                if(lxp .ne. 2)cycle
             endif
             if(pcu .eq. '3  ')then
                if(lxp .ne. 3)cycle
             endif
             if(pcu .eq. '12 ')then
                if(lxp .eq. 3)cycle
             endif
             if(pcu .eq. '23 ')then
                if(lxp .eq. 1)cycle
             endif
             if(pcu .eq. '13 ')then
                if(lxp .eq. 2)cycle
             endif
               if(pcu .eq. '21 ')then
                if(lxp .eq. 3)cycle
             endif
             if(pcu .eq. '32 ')then
                if(lxp .eq. 1)cycle
             endif
             if(pcu .eq. '31 ')then
                if(lxp .eq. 2)cycle
             endif
         endif  

      do j=1,1024/Nchan(lxp)

      jfile=0
       jfiles=1
 11    continue
       
 
       if(Ecmin(j,lxp) .ge. Emin(jfiles) .and. Ecmax(j,lxp) .
     1 le. Emax(jfiles))then
       jfile=jfiles
       else
         
       jfiles=jfiles+1
       if(jfiles .le. jfile_num)goto 11
       endif
      
       if(jfile .ne. 0)then
          back_rate(jfile) = back_rate(jfile)+bkgspec(j,lxp)
       endif

       enddo
       
       enddo
      end

      subroutine read_bkg(bkgspec,bkgfilelist,status)

      implicit real*8(a-h,o-z)

       character*60 bkgfile(3)
      character*100 bkgfilelist
       
      dimension bkgspec(2000,3),rate(2000)
      

      integer status,unit,readwrite,blocksize
      logical anynull,casesan

      casesan=.FALSE.

      
      open(unit=47,err=707,file=bkgfilelist,status='old')
 705  continue
      read(47,*,end=706) lxp,bkgfile(lxp)
       
      
      status=0
      call ftgiou(unit,status)
      if (status .gt. 0)call printerror(status)
      readwrite=0
      call ftopen(unit,bkgfile(lxp),readwrite,blocksize,status)
      if (status .gt. 0)call printerror(status)
      ntable = 2
      call ftmahd(unit,ntable,hdutype,status)
      if (status .gt. 0)call printerror(status)
      
       call FTGCNO(unit,casesan,'RATE',icol,status)
      
       if (status .gt. 0)then
          ntable = ntable+1
           call ftmahd(unit,ntable,hdutype,status)
           call FTGCNO(unit,casesan,'RATE',icol,status)
        if (status .gt. 0)call printerror(status)
        endif

        call ftgnrw(unit,nrows,status)
        
        irow=1
        ifelem=1
        call ftgcvd(unit,icol,irow,ifelem,nrows,nullj,rate,anynull
     1 ,status)

       
        
        
        
       
        do j=1,nrows
          
            bkgspec(j,lxp)=rate(j)
          
        enddo   
       
        if(status .eq. 0)then
           write(*,*) 'Obtained back rate for laxpc ',lxp*10,
     1' using ',bkgfile(lxp)
           else
           write(*,*) 'Trouble getting back rates, no correction'
        endif
        call ftclos(unit, status)
        call ftfiou(unit, status)

        goto 705
706    continue
       goto 708
 707    continue
        write(*,*) 'No background files and hence no correction'
 708    continue
       

        end
C     +++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      subroutine read_data_fits(time,imax,deltat,NN,
     1filename,ave,itstart,itstop,jgti,freq_max,timemem,
     2NNC,nrows,jfile_num,itstartu,itstopu,jgtiu,Enemin,Enemax,Nfile,
     3pcu,user_gti_file,gtinotfits,ilayer)


      IMPLICIT DOUBLE PRECISION(a-h,o-z)


     
      real*8 time(NN)
      real*8 tstart(500),tstop(500)
	real*8 tstartu(500),tstopu(500)
      real deltata,deltatb,ave(jfile_num+1)
      integer nrows(jfile_num+1)
      integer icmin(jfile_num+1),icmax(jfile_num+1)
      real*8 Enemin(Nfile),Enemax(Nfile)
	character*3 pcu

      character*50 filename(jfile_num),user_gti_file

      character*80 object_name

      character*80 errmessage,comment
      logical casesan,gtinotfits
      integer itstart(500),itstop(500)
	integer itstartu(500),itstopu(500)

        integer status,unit,readwrite,blocksize
      logical anynull

      real*8 timem(NN)
      real enem(NN)
      integer lxpm(NN),ilaym(NN)

        casesan=.FALSE.
	

        call read_usergti(user_gti_file,tstartu,tstopu,jgtiu,gtinotfits)
     
 

         deltata = 10e-6
 

         write(*,*) "No. of energy bins", jfile_num

         

         do j=1,jfile_num+1
            nrows(j) = 0
         enddo



        status=0
      call ftgiou(unit,status)
      if (status .gt. 0)call printerror(status)
      readwrite=0
      call ftopen(unit,filename(1),readwrite,blocksize,status)
      if (status .gt. 0)then
      call printerror(status)
      write(*,*) 'event file not found'
      write(*,*) filename(1)
      stop
      endif
      

      call FTGKYD(unit,'TSTART',tstart(1),comment,status)
      call FTGKYD(unit,'TSTOP',tstop(1),comment,status)

      if(jgtiu .gt. 0)then
         if(tstartu(1) .gt. tstart(1))then
            do j=1,jgtiu
               tstartu(j) = tstartu(j)-tstart(1)
               tstopu(j) = tstopu(j)-tstart(1)
               
            enddo
         endif
      endif

!      write(*,*) tstart(1),tstop(1)
     

      ntable = 2
      call ftmahd(unit,ntable,hdutype,status)
      if (status .gt. 0)call printerror(status)

      call ftgnrw(unit,nrowsF,status)


      if(nrowsf .gt. NN-1)then
         write(*,*) "no of events too large: ",nrowf
         write(*,*) "taking only: ", NN-1, ' events'
         nrowsf=NN-1
      endif   
   

      irow=1
      ifelem=1
      call FTGCNO(unit,casesan,'Time',icol,status)
        call ftgcvd(unit,icol,irow,ifelem,nrowsf,nullj,timem,anynull
     1 ,status)

        if (status .gt. 0)call printerror(status)

        irow=1
        ifelem=1
        call FTGCNO(unit,casesan,'Energy',icol,status)
        call ftgcve(unit,icol,irow,ifelem,nrowsf,nullj,enem,anynull
     1 ,status)

        irow=1
        ifelem=1
        call FTGCNO(unit,casesan,'LAXPC_NO.',icol,status)
        call ftgcvj(unit,icol,irow,ifelem,nrowsf,nullj,lxpm,anynull
     1 ,status)

        irow=1
        ifelem=1
        call FTGCNO(unit,casesan,'layer',icol,status)
        call ftgcvj(unit,icol,irow,ifelem,nrowsf,nullj,ilaym,anynull
     1 ,status)
        
    

        if (status .gt. 0)call printerror(status)

       


        if (status .gt. 0)call printerror(status)
        

      

c$$$ 10    continue
c$$$       read(10,*,end=20) timea,ia,ia,Ene,lxp
       do i =1,nrowsf
          lxp = lxpm(i)
          ene=enem(i)
          timea=timem(i)
         
	if(pcu .ne. 'all')then
 
                    if(pcu .eq. '1  ')then
                if(lxp .ne. 1)cycle
             endif
             if(pcu .eq. '2  ')then
                if(lxp .ne. 2)cycle
             endif
             if(pcu .eq. '3  ')then
                if(lxp .ne. 3)cycle
             endif
             if(pcu .eq. '12 ')then
                if(lxp .eq. 3)cycle
             endif
             if(pcu .eq. '23 ')then
                if(lxp .eq. 1)cycle
             endif
             if(pcu .eq. '13 ')then
                if(lxp .eq. 2)cycle
             endif
               if(pcu .eq. '21 ')then
                if(lxp .eq. 3)cycle
             endif
             if(pcu .eq. '32 ')then
                if(lxp .eq. 1)cycle
             endif
             if(pcu .eq. '31 ')then
                if(lxp .eq. 2)cycle
             endif

       endif
       if(ilayer .gt. 0)then
          if(ilayer .ne. ilaym(i))cycle
       endif
       
       jfile=0
       jfiles=1
 11    continue
       
 
       if(Ene .ge. Enemin(jfiles) .and. Ene .le. Enemax(jfiles))then
       jfile=jfiles
       else
         
       jfiles=jfiles+1
       if(jfiles .le. jfile_num)goto 11
       endif
      
       if(jfile .ne. 0)then
          jshift = (jfile-1)*NNC+1
        time(jshift+nrows(jfile))=timea
        nrows(jfile)=nrows(jfile)+1
         if(nrows(jfile) .gt. NNC)then
         write(*,*) 'too many data points',nrows(jfile),NNC,jfile
         stop
        endif
       else
         jfile=jfile_num+1
         jshift = (jfile-1)*NNC+1
        time(jshift+nrows(jfile))=timea
        nrows(jfile)=nrows(jfile)+1
         if(nrows(jfile) .gt. NNC)then
         write(*,*) 'too many data points',nrows(jfile),NNC,jfile
         stop
        endif
         
       endif
      
       enddo
 
       
      

       do jfile=1,jfile_num+1

          

          if(jfile .le. jfile_num)then
      write(*,*)"No.of events in the ",jfile," data set = ",nrows(jfile)
        else
       write(*,*)"No.of events in other energy bands = ",nrows(jfile)
        endif
       
      

       if(jfile .eq. 1)then
!          ibin=1
      ibin = nint((1./(2.*freq_max))/deltata)
      if(ibin .eq. 0)ibin=1

      deltat=ibin*deltata

      
       jgti=1
       
     
     


          timemem=tstart(1)
          

          do j=1,jgti
           itstart(j) = int((tstart(j)-timemem)/deltat)+1 
           itstop(j) = int((tstop(j)-timemem)/deltat)+1 
           
          enddo 
	if(jgtiu .ne. 0)then
	 do j=1,jgtiu
           itstartu(j) = int((tstartu(j))/deltat)+1 
	
           itstopu(j) = int((tstopu(j))/deltat)+1 
           
          enddo 
	endif

          deltatb=deltata
          
          Tot_time = (tstop(jgti)-timemem)
          imax = Tot_time/deltat
!          timemem=time(1)
!          Tot_time = (time(nrows)-time(1))
c$$$           if(imax .gt. NN)then
c$$$         write(*,*) 'too many LC points',imax,NN
c$$$         imax=NN
c$$$          endif
          

     

      endif

      ave(jfile) = nrows(jfile)*deltat/Tot_time

!      write(*,*) nrows(jfile),jfile
!      write(*,*) ave(jfile),'average',Tot_time,timemem,tstop(jgti)

      
 

      
      enddo
  

      

      end

C *************************************************************************
      subroutine printerror(status)

C  This subroutine prints out the descriptive text corresponding to the
C  error status value and prints out the contents of the internal
C  error message stack generated by FITSIO whenever an error occurs.

      integer status
      character errtext*30,errmessage*80

C  Check if status is OK (no error); if so, simply return
      if (status .le. 0)return

C  The FTGERR subroutine returns a descriptive 30-character text string that
C  corresponds to the integer error status number.  A complete list of all
C  the error numbers can be found in the back of the FITSIO User's Guide.
      call ftgerr(status,errtext)
      print *,'FITSIO Error Status =',status,': ',errtext

C  FITSIO usually generates an internal stack of error messages whenever
C  an error occurs.  These messages provide much more information on the
C  cause of the problem than can be provided by the single integer error
C  status value.  The FTGMSG subroutine retrieves the oldest message from
C  the stack and shifts any remaining messages on the stack down one
C  position.  FTGMSG is called repeatedly until a blank message is
C  returned, which indicates that the stack is empty.  Each error message
C  may be up to 80 characters in length.  Another subroutine, called
C  FTCMSG, is available to simply clear the whole error message stack in
C  cases where one is not interested in the contents.
      call ftgmsg(errmessage)
      do while (errmessage .ne. ' ')
          print *,errmessage
          call ftgmsg(errmessage)
      end do
      end
C *************************************************************************
      subroutine deletefile(filename,status)

C  A simple little routine to delete a FITS file

      integer status,unit,blocksize
      character*(*) filename

C  Simply return if status is greater than zero
      if (status .gt. 0)return

C  Get an unused Logical Unit Number to use to open the FITS file
      call ftgiou(unit,status)

C  Try to open the file, to see if it exists
      call ftopen(unit,filename,1,blocksize,status)

      if (status .eq. 0)then
C         file was opened;  so now delete it 
          call ftdelt(unit,status)
      else if (status .eq. 103)then
C         file doesn't exist, so just reset status to zero and clear errors
          status=0
          call ftcmsg
      else
C         there was some other error opening the file; delete the file anyway
          status=0
          call ftcmsg
          call ftdelt(unit,status)
      end if

C  Free the unit number for later reuse
      call ftfiou(unit, status)
      end
      subroutine read_usergti(user_gti_file,tstartu,tstopu,
     1 jgtiu,gtinotfits)

      IMPLICIT DOUBLE PRECISION(a-h,o-z)

      character*50 user_gti_file

      real*8 tstartu(500),tstopu(500)


      integer status,unit,readwrite,blocksize
      logical anynull
      logical casesan,gtinotfits

       casesan=.FALSE.
       gtinotfits=.true.
          
      	jgtiu=0
	open(unit=33,file=user_gti_file,status='old',err=212)
	
	j=1
213	continue
	read(33,*,err=214,end=212) tstartu(j),tstopu(j)
	jgtiu=j
	j=j+1
	goto 213
 212	continue
        goto 217

 214    continue
        if(jgtiu .eq. 0)then
           status=0
        call ftgiou(unit,status)
      
      readwrite=0
      call ftopen(unit,user_gti_file,readwrite,blocksize,status)

      if(status .gt. 0)return

      ntable = 2
      call ftmahd(unit,ntable,hdutype,status)
      if (status .gt. 0)then
        call printerror(status)
        return
      endif

      call ftgnrw(unit,jgtiu,status)
         
      irow=1
      ifelem=1
      call FTGCNO(unit,casesan,'START',icol,status)
        call ftgcvd(unit,icol,irow,ifelem,jgtiu,nullj,tstartu,anynull
     1 ,status)

        irow=1
      ifelem=1
      call FTGCNO(unit,casesan,'STOP',icol,status)
        call ftgcvd(unit,icol,irow,ifelem,jgtiu,nullj,tstopu,anynull
     1 ,status)

        
         if (status .gt. 0)then
        call printerror(status)
        jgtiu=0
        return
         endif
        
         gtinotfits=.false.

      endif

 217  continue

      

        end
      

     

      subroutine readinput(filename,fileout,user_gti_file,pcu,freq_max
     1 ,freq_min,ifreq,frequser,lxpref,eneinput,taud)


      implicit real*8(a-h,o-z)
      character*50 filename,fileout,user_gti_file,eneinput
       character*3 pcu



      integer    larg,       mxopts
      parameter (larg = 256, mxopts = 64)
*
      integer            iarg, ptr, arglen, nflags, argidx
      logical            done, more, hasarg(mxopts)
      character          flags(mxopts)
      character *(larg)  arg, optarg
*
      common  / gtoptc /
     $     iarg, ptr, arglen, nflags, argidx, done, more, hasarg,
     $     flags, arg, optarg
*
      save / gtoptc /

      integer      status,getopt
        character      flag
        character*300 use_err,statement
        
        logical  argset, first

        
         filename='level2.event.fits'
      fileout='level2.event'
      user_gti_file='usergti'
      pcu='all'
      freq_max=100.
      freq_min=1.0
      ifreq=0
      frequser=10.
      lxpref=0    
      eneinput='enefiles'
      taud = 42.*1e-6 

        use_err = '[-u user gti file] [-p (which pcu? all or e.g. 12)]
     1 [-h max freq] [-l min freq] [-f frequser] [-r ref_PCU]
     2 [-e energy define file] [-o output filename]   eventfile'
        use_err = 'USAGE: freq_lag '//use_err

       first = .true.
        argset=.false.
 485    continue

      status=getopt('u:p:h:l:f:r:e:o:d:',flag,argset,nargs,first)

      if (status .eq. 1) then


          if (flag .eq. 'd') then
                      if (argset) then
                    

                    read (optarg, *,err=915) taud
                    taud=taud*1e-6

                    goto 916
 915                continue
                    write(*,*) 'error reading argument for flag d'
                    write(*,*) 'Taking default value'
                    goto 9000
 916                continue
                    
                    endif
          endif



          if (flag .eq. 'f') then
                      if (argset) then
                    

                    read (optarg, *,err=925) frequser
                    ifreq=1

                    goto 926
 925                continue
                    write(*,*) 'error reading argument for flag f'
                    write(*,*) 'Taking default value'
                    goto 9000
 926                continue
                    
                    endif
          endif



         if (flag .eq. 'l') then
                      if (argset) then
                    

                    read (optarg, *,err=935) freq_min
                    
                    goto 936
 935                continue
                    write(*,*) 'error reading argument for flag l'
                    write(*,*) 'Taking default value of', freq_min
                    goto 9000
 936                continue
                    
                    endif
          endif
         
           if (flag .eq. 'u') then
                      if (argset) then
                    
                    read (optarg, '(A50)',err=945) user_gti_file

                    goto 946
 945                continue
                    write(*,*) 'error reading argument for flag u'
                    write(*,*) 'Give name of user gti file:  '
                    read(*,*) user_gti_file

!                    goto 9000
 946                continue
                    
                    endif
          endif

          if (flag .eq. 'p') then
                      if (argset) then
                    
                    read (optarg, '(A3)',err=955) pcu

                    goto 956
 955                continue
                    write(*,*) 'error reading argument for flag p'
                    write(*,*) 'Using all PCUS'
                    goto 9000
 956                continue
                    
                    endif
          endif
         
          
          if (flag .eq. 'h') then
                      if (argset) then
                    
!                    read (optarg, '(D12.5)',err=955) deltat
                    read (optarg, *,err=965) freq_max
                    
                    goto 966
 965                continue
                    write(*,*) 'error reading argument for flag h'
                    write(*,*) 'Taking default value of', freq_max
                    goto 9000
 966                continue
                    
                    endif
          endif


          if (flag .eq. 'o') then
                      if (argset) then
                    
                    read (optarg, '(A50)',err=975) fileout
                   
                    goto 976
 975                continue
                    write(*,*) 'error reading argument for flag o'
                    goto 9000
 976                continue
                    
                    endif
          endif

             if (flag .eq. 'e') then
              
                      if (argset) then
                    
                    read (optarg, '(A50)',err=985) eneinput
                    
                    goto 986
 985                continue
                    write(*,*) 'error reading argument for flag e'
                    write(*,*) 'Using default energy file eneinput'
                    goto 9000
 986                continue
                    
                    endif
          endif
          
          if (flag .eq. 'r') then
                      if (argset) then
                    
!                    read (optarg, '(D12.5)',err=955) deltat
                    read (optarg, *,err=995) lxpref
                    if(lxpref .gt. 3)lxpref=0
                    goto 996
 995                continue
                    write(*,*) 'error reading argument for flag r'
                    write(*,*) 'Taking default value'
                    goto 9000
 996                continue
                    
                    endif
          endif

          
          goto 485
        endif

        if (status .lt. 0) then
       write(*,*) use_err
        go to 9000
      else
        if (nargs .eq. 0 .or. argidx .ne. nargs) then
           write(*,*) use_err
          go to 9000
        end if
      end if
             
        call getarg (nargs, filename)
       
       
 9000   continue
        
         write(*,*) 'Event file being used: ',filename
         write(*,*) 'PCUs being used: ',pcu
        write(*,*) 'Output file post-root name: ',fileout
        write(*,*) 'User GTI file name: ',user_gti_file
        
       

      end

C     +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* -*- fortran -*- ------------------------------------------------------
*
*     John W. Eaton
*     jwe@che.utexas.edu
*     Department of Chemical Engineering
*     The University of Texas at Austin
*
*-----------------------------------------------------------------------
*
      integer function getopt (string, flag, argset, nargs, first)
*
      integer        nargs
      character      flag
      character *(*) string
      logical        argset, first
*
*-----------------------------------------------------------------------
*
      integer  stdin, stdout, stderr
*
      parameter ( stdin = 5, stdout = 6, stderr = 0 )

*
      integer    larg,       mxopts
      parameter (larg = 256, mxopts = 64)
*
      integer            iarg, ptr, arglen, nflags, argidx
      logical            done, more, hasarg(mxopts)
      character          flags(mxopts)
      character *(larg)  arg, optarg
*
      common  / gtoptc /
     $     iarg, ptr, arglen, nflags, argidx, done, more, hasarg,
     $     flags, arg, optarg
*
      save / gtoptc /
*
* -- End

*
      integer iargc, lennb, strln, i
*
      if (first) then
*
        first = .false.
*
* -- If the user passes in a character vector for the option string,
* -- he loses.
*
        strln = lennb (string, len (string))
*
        nflags = 0
        i = 1
    1   if (strln .gt. 0) then
          strln = strln - 1
          nflags = nflags + 1
          if (nflags .gt. mxopts) then
            write (stderr, '(a)')
     $           'getopt: too many flags in option list'
            getopt = -1
            return
          end if
          if (string(i:i) .eq. ':') then
            write (stderr, '(a)') 'getopt: garbled option list'
            getopt = -1
            return
          end if
          flags (nflags) = string(i:i)
          i = i + 1
          hasarg(nflags) = (string(i:i) .eq. ':')
          if (hasarg (nflags)) then
            i = i + 1
            strln = strln - 1
          end if
          go to 1
        end if
        done = .false.
        more = .false.
        iarg = 1
        nargs = iargc ()
      end if
*
      if (done) then
        write (stderr, '(a)') 'getopt: no more options'
        argset = .false.
        flag = ' '
        argidx = iarg
        getopt = 0
        return
      end if
*
      if (iarg .gt. nargs) then
        done = .true.
        argset = .false.
        flag = ' '
        argidx = iarg
        getopt = 0
        return
      end if
*
      if (.not. more) then
        call getarg (iarg, arg)
*
* -- Check for explicit end of options.
*
        if (arg .eq. '--') then
          done = .true.
          argset = .false.
          flag = ' '
          iarg = iarg + 1
          argidx = iarg
          getopt = 0
          return
        end if
*
* -- Does the argument match a flag?
*
        if (arg(1:1) .eq. '-') then
          more = .true.
          arglen = lennb (arg, len (arg))
          if (arglen .eq. 1) then
            done = .true.
            argset = .false.
            flag = ' '
            argidx = iarg
            getopt = 0
            return
          end if
          arglen = arglen - 1
          ptr = 2
*
        else
*
* -- End of options implied.
*
          done = .true.
          argset = .false.
          flag = ' '
          argidx = iarg
          getopt = 0
          return
*
        end if
      end if
*
* -- Process flags.
*
      do 10 i = 1, nflags
        if (arg(ptr:ptr) .eq. flags(i)) then
          flag = flags(i)
          if (hasarg(i)) then
            if (iarg .gt. nargs) then
              write (stderr, '(a)') 'getopt: option string missing'
              write (stderr, '(a,a)') 'getopt: option flag is: ', flag
              getopt = -1
              return
            end if
            iarg = iarg + 1
            call getarg (iarg, optarg)
            argset = .true.
          else
            argset = .false.
          end if
          getopt = 1
          go to 9000
        end if
   10 continue
*
      write (stderr, '(a,a)')
     $     'getopt: unrecognized option: -', arg(ptr:ptr)
      getopt = -1
*
 9000 continue
*
      ptr = ptr + 1
      arglen = arglen - 1
      more = (arglen .gt. 0)
      if (.not. more) then
        iarg = iarg + 1
      endif
      argidx = iarg
*
      return
      end
C     +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* -*- fortran -*- ------------------------------------------------------
*
*     John W. Eaton
*     jwe@che.utexas.edu
*     Department of Chemical Engineering
*     The University of Texas at Austin
*
*-----------------------------------------------------------------------
*
      integer function lennb (string, nchmax)
*
      integer       nchmax
      character *1  string(*)
*
*-----------------------------------------------------------------------
*
*     Returns the position of the last non blank character in a
*     characterstring. 
*
*     Parameter list:
*
*       string : Character string for which one desires to find the
*                position of the last non blank character (from the
*                left).
*
*       nchmax : The maximum possible value of the position of the last
*                non blank character in string.  Lennb searches
*                backwards from this location.
*
*-----------------------------------------------------------------------
*
      integer i
*
* -- Begin.
*
      lennb = 0
*
      do 10 i = nchmax, 1, -1
        if (string(i) .ne. ' ') then
          lennb = i
          go to 9000
        end if
   10 continue
*
 9000 continue
*
      return
      end
C     +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      subroutine read_resp(respfile,ecmin,ecmax,Nchan,respfilelist
     1,status)

      implicit real*8(a-h,o-z)

       character*60 respfile(3)
      character*100 respfilelist
       
      dimension ecmin(2000,3),ecmax(2000,3),emin(2000),emax(2000)
      dimension Nchan(3)
      

      integer status,unit,readwrite,blocksize
      logical anynull,casesan

      casesan=.FALSE.

      
      open(unit=47,err=707,file=respfilelist,status='old')
 705  continue
      read(47,*,end=706) lxp,respfile(lxp)
       
      
      status=0
      call ftgiou(unit,status)
      if (status .gt. 0)call printerror(status)
      readwrite=0
      call ftopen(unit,respfile(lxp),readwrite,blocksize,status)
      if (status .gt. 0)call printerror(status)
      ntable = 2
      call ftmahd(unit,ntable,hdutype,status)
      if (status .gt. 0)call printerror(status)
      
       call FTGCNO(unit,casesan,'E_min',icol,status)
      
       if (status .gt. 0)then
          ntable = ntable+1
           call ftmahd(unit,ntable,hdutype,status)
           call FTGCNO(unit,casesan,'E_min',icol,status)
        if (status .gt. 0)call printerror(status)
        endif

        call ftgnrw(unit,nrows,status)
        
        irow=1
        ifelem=1
        call ftgcvd(unit,icol,irow,ifelem,nrows,nullj,emin,anynull
     1 ,status)

       
        call FTGCNO(unit,casesan,'E_max',icol,status)
        call ftgcvd(unit,icol,irow,ifelem,nrows,nullj,emax,anynull
     1 ,status)
        
        Nchan(lxp) = 1024/nrows
        do j=1,nrows
          
           ecmin(j,lxp)=emin(j)
           ecmax(j,lxp)=emax(j)
        enddo   
       
        if(status .eq. 0)then
           write(*,*) 'Obtained energy information fo laxpc ',lxp*10,
     1' using ',respfile(lxp)
        endif
        call ftclos(unit, status)
        call ftfiou(unit, status)

        goto 705
706    continue
       goto 708
 707    continue
        write(*,*) 'No response file and hence no energy information'
 708    continue
       

        end
